package es.upm.dit.adsw.tema2.a_pong;

import java.awt.*;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;

public class Paddle
        implements Thing, KeyListener {
    private static final int HEIGHT = 10;
    private static final int WIDTH = 100;

    private int cx;
    private int cy;
    private Color body = Color.DARK_GRAY;

    private final Screen screen;

    public Paddle(Screen screen) {
        this.screen = screen;
    }

    public void set(Color color) {
        body = color;
    }

    public void setXY(int x0, int y0) {
        cx = x0;
        cy = y0;
    }

    public Color getColor() {
        return body;
    }

    public void paint(Graphics2D g) {
        if (body != null) {
            g.setColor(body);
            g.fillRect(cx - WIDTH / 2, cy - HEIGHT / 2, WIDTH, HEIGHT);
        }
    }

    public boolean hit(int cx, int cy1, int cy2) {
        if (cx < this.cx - WIDTH / 2)
            return false;
        if (cx > this.cx + WIDTH / 2)
            return false;
        if (cy2 > cy1) {    // bola bajando
            int margin = this.cy - 10;
            return cy1 < margin && cy2 >= margin;
        } else {            // bola subiendo
            int margin = this.cy + 10;
            return cy1 > margin && cy2 <= margin;
        }
    }

    @Override
    public void keyTyped(KeyEvent e) {
    }

    @Override
    public void keyPressed(KeyEvent e) {
        switch (e.getKeyCode()) {
            case KeyEvent.VK_LEFT:
                cx = Math.max(WIDTH / 2, cx - 15);
                break;
            case KeyEvent.VK_RIGHT:
                cx = Math.min(cx + 15, screen.getWidth() - WIDTH / 2);
                break;
        }
        screen.paint();
    }

    @Override
    public void keyReleased(KeyEvent e) {
    }
}
