package es.upm.dit.adsw.tema2.balls.c_readers_writers;

import es.upm.dit.adsw.ej3.Game;

public class RW_Monitor {
    private int nReaders= 0;
    private int nWriters= 0;

    public synchronized int getNReaders() {
        return nReaders;
    }

    public synchronized int getNWriters() {
        return nWriters;
    }

    public synchronized void openReading() {
        nReaders++;
        invariant();
    }

    public synchronized void closeReading() {
        nReaders--;
        invariant();
    }

    public synchronized void openWriting() {
        nWriters++;
        invariant();
    }

    public synchronized void closeWriting() {
        nWriters--;
        invariant();
    }

    void invariant() {
        if (getNReaders() > 0 && getNWriters() > 0)
            System.err.println("simultaneous readers & writers");
        if (getNWriters() > 1)
            System.err.println("more than 1 simultaneous writer");
    }

    void waiting() {
        try {
            wait();
        } catch (InterruptedException ignored) {
        }
    }
}
