package es.upm.dit.adsw.tema2.balls.c_readers_writers;

public class RW_Monitor_3 extends RW_Monitor {
    private int nReaders = 0;
    private int nWriters = 0;

    private int waitingWriters = 0;

    public synchronized void openReading() {
        while (!canRead())
            waiting();
        nReaders++;
        invariant();
    }

    private boolean canRead() {
        if (nWriters > 0) return false;
        if (waitingWriters > 0) return false;
        return true;
    }

    public synchronized void closeReading() {
        nReaders--;
        notifyAll();
        invariant();
    }

    public synchronized void openWriting() {
            waitingWriters++;
        while (!canWrite())
            waiting();
            waitingWriters--;
        nWriters++;
        invariant();
    }

    private boolean canWrite() {
        if (nReaders > 0) return false;
        if (nWriters > 0) return false;
        return true;
    }

    public synchronized void closeWriting() {
        nWriters--;
        notifyAll();
        invariant();
    }
}
