package es.upm.dit.adsw.tema2.balls.d_narrow_bridge;

public class NB_Monitor_v2 extends NB_Monitor {
    private int nNS = 0;    // no. viajando de N a S
    private int nSN = 0;    // no. viajando de S a N

    private void invariant() {
        if (nNS > 0 && nSN > 0)
            throw new IllegalStateException();
    }

    public synchronized void entraN() {
        while (nSN > 0)
            waiting();
        nNS++;
        invariant();
    }

    public synchronized void entraS() {
        while (nNS > 0)
            waiting();
        nSN++;
        invariant();
    }

    public synchronized void saleN() {
        nSN--;
        invariant();
        notifyAll();
    }

    public synchronized void saleS() {
        nNS--;
        invariant();
        notifyAll();
    }

    private synchronized void waiting() {
        try {
            wait();
        } catch (InterruptedException ignored) {
        }
    }
}
