package es.upm.dit.adsw.tema2.bg_task;

/**
 * Agente auxiliar para esperar eventos de terminación.
 */
public class Listener {
    private boolean ready = false;
    private String result = null;

    /**
     * Alguien anuncia un resultado.
     * @param result resultado.
     */
    public synchronized void publish(String result) {
        this.result = result;
        ready = true;
        notifyAll();
    }

    /**
     * Para obtener el resultado. Espera a que haya alguno disponible.
     * @return resultado.
     */
    public synchronized String getResult() {
        while (!ready)
            waiting();
        return result;
    }

    private void waiting() {
        try {
            wait();
        } catch (InterruptedException ignored) {
        }
    }
}
