package es.upm.dit.adsw.tema2.bounded_buffer;

import java.util.HashSet;
import java.util.Set;

public class TestConsumer extends Thread {
    private final Buffer<Integer> buffer;
    private final Set<Integer> expected;

    public TestConsumer(Buffer<Integer> buffer, Set<Integer> expected) {
        this.buffer = buffer;
        this.expected = expected;
    }

    @Override
    public void run() {
        try {
            Set<Integer> received = new HashSet<>();
            while (received.size() < expected.size()) {
                Integer x = buffer.get();
                if (received.contains(x))
                    throw new IllegalStateException("dato suplicado");
                if (!expected.contains(x))
                    throw new IllegalStateException("dato inesperado");
                received.add(x);
            }
            if (!buffer.isEmpty())
                throw new IllegalStateException("buffer no vacio");
            System.out.println("consumer ok");
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }
}
