package es.upm.dit.adsw.tema2.contador;

import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.locks.Lock;
import java.util.concurrent.locks.ReentrantLock;

public class Contador {
    private int cuenta = 0;
    Lock cerrojo = new ReentrantLock();

    void incrementa(int v) {
        try {
            cerrojo.lock();
//        cuenta += v;
            int registro = cuenta;
            registro = registro + v;
            cuenta = registro;
        } finally {
            cerrojo.unlock();
        }
    }

    void decrementa(int v) {
        try {
            cerrojo.lock();
            cuenta -= v;
        } finally {
            cerrojo.unlock();
        }
    }

    public int getN() {
        return cuenta;
    }

    private static void nap(int ms) {
        try {
            Thread.sleep((long) (ms * Math.random()));
        } catch (InterruptedException ignored) {
        }
    }

    public static void main(String[] args)
            throws InterruptedException {
        Contador cc = new Contador();

        List<Thread> threadList = new ArrayList<>();
        for (int i = 0; i < 100; i++)
            threadList.add(new Robot(cc));

        for (Thread thread : threadList)
            thread.start();     // arranca la thread
        for (Thread thread : threadList)
            thread.join();      // espera a que termine la thread
        System.out.println("getV(): " + cc.getN());
    }

    private static class Robot extends Thread {
        private final Contador cc;

        Robot(Contador cc) {
            this.cc = cc;
        }

        @Override
        public void run() {
            nap(100);
            cc.incrementa(1);
            nap(100);
            cc.decrementa(1);
        }
    }
}
